diff --git a/daemonize.c b/daemonize.c
index 2aaa3705245..f446e2ada96 100644
--- a/daemonize.c
+++ b/daemonize.c
@@ -268,6 +268,8 @@ int daemonize(char* name, int * own_pgid)
 			/*parent process => exit */
 			exit(0);
 		}
+
+		is_pre_daemon = 0;  /* attendant process at this point */
 	}
 
 #ifdef __OS_linux
diff --git a/globals.h b/globals.h
index 118537c669d..7bd76f54a4b 100644
--- a/globals.h
+++ b/globals.h
@@ -113,6 +113,7 @@ extern unsigned long pkg_mem_size;
 extern int reply_to_via;
 
 extern int is_main;
+extern int is_pre_daemon;
 
 extern int memlog;  /*!< debugging level for printing memory debugs */
 extern int memdump; /*!< debugging level for dumping memory status */
diff --git a/main.c b/main.c
index 4ac0ea16a85..7364a6f81b2 100644
--- a/main.c
+++ b/main.c
@@ -311,6 +311,9 @@ char **my_argv;
 
 int is_main = 1; /* flag = is this the  "main" process? */
 
+/* flag = is this an initial, pre-daemon process ? */
+int is_pre_daemon = 1;
+
 char* pid_file = 0; /* filename as asked by user */
 char* pgid_file = 0;
 
diff --git a/modules/rest_client/rest_client.c b/modules/rest_client/rest_client.c
index 311419de02e..8c9429d1f29 100644
--- a/modules/rest_client/rest_client.c
+++ b/modules/rest_client/rest_client.c
@@ -41,6 +41,7 @@
 
 #include "rest_methods.h"
 #include "../../ssl_init_tweaks.h"
+#include "../../pt.h"
 
 /*
  * Module parameters
diff --git a/modules/rest_client/ssl_tweaks.c b/modules/rest_client/ssl_tweaks.c
new file mode 100644
index 00000000000..ff7f2000131
--- /dev/null
+++ b/modules/rest_client/ssl_tweaks.c
@@ -0,0 +1,49 @@
+/*
+ * Copyright (C) 2020 OpenSIPS Project
+ *
+ * This file is part of opensips, a free SIP server.
+ *
+ * opensips is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * opensips is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
+ *
+ */
+
+#define _GNU_SOURCE
+
+#include <openssl/ssl.h>
+#include <dlfcn.h>
+
+#include "../../sr_module.h"
+#include "../../globals.h"
+
+/* don't call the real openssl function (from libssh's destructor) when the
+ * pre-daemon processes exit */
+void BN_clear_free(BIGNUM *a)
+{
+	void (*real_BN_clear_free)(BIGNUM *a);
+	static int have_tls_mgm = -1;
+
+	if (have_tls_mgm == -1)
+		have_tls_mgm = module_loaded("tls_mgm");
+
+	if (have_tls_mgm && !no_daemon_mode && is_pre_daemon) {
+		return;
+	} else {
+		real_BN_clear_free = dlsym(RTLD_NEXT, "BN_clear_free");
+		if (!real_BN_clear_free)
+			return;
+
+		real_BN_clear_free(a);
+	}
+}
